// cloneDemo.java

class engine implements Cloneable
{
   private int numCylinders;

   engine (int numCylinders)
   {
      this.numCylinders = numCylinders;
   }

   int getNumCylinders () { return numCylinders; }

   public Object clone () throws CloneNotSupportedException
   {
      return super.clone ();
   }
}

class vehicle implements Cloneable
{
   private String name;
   private engine e;

   vehicle (String name, engine e)
   {
      this.name = name;
      this.e = e;
   }

   String getName () { return name; }
   engine getEngine () { return e; }

   public Object clone () throws CloneNotSupportedException
   {
      vehicle newObject = (vehicle) super.clone ();

      if (this.e != null)
          newObject.e = (engine) this.e.clone ();

      if (this.name != null)
          newObject.name = new String (this.name);

      return newObject;
   }
}

class cloneDemo
{
   public static void main (String [] args)
   {
       vehicle v1 = new vehicle ("Halfton Pickup", new engine (6));
       vehicle v2 = null;

       try
       {
          v2 = (vehicle) v1.clone ();
       }
       catch (CloneNotSupportedException e)
       {
          System.out.println (e);
       }

       if (v1 == v2)
           System.out.println ("v2 is the same as v1");
       else
           System.out.println ("v2 is a duplicate of v1");

       String name1 = v1.getName ();
       String name2 = v2.getName ();

       if (name1 == name2)
           System.out.println ("name2 is the same as name1");
       else
           System.out.println ("name2 is a duplicate of name1");

       engine e1 = v1.getEngine ();
       engine e2 = v2.getEngine ();

       if (e1 == e2)
           System.out.println ("e2 is the same as e1");
       else
           System.out.println ("e2 is a duplicate of e1");

       if (e1.getNumCylinders () == e2.getNumCylinders ())
           System.out.println ("Number of cylinders match");
       else
           System.out.println ("Number of cylinders differ");
   }
}
