// shapes.java

abstract class shape
{
    abstract double area ();
}

class point extends shape
{
   private double x, y;

   point (double x, double y)
   {
      this.x = x; this.y = y;
   }

   double getX () { return x; }
   double getY () { return y; }

   double area () { return 0.0; }
}

class circle extends point
{
   private double radius;

   circle (double x, double y, double radius)
   {
      super (x, y);
      this.radius = radius;
   }

   double getRadius () { return radius; }

   double area () { return Math.PI * radius * radius; }
}

class rectangle extends shape
{
   private double length, width;

   rectangle (double length, double width)
   {
      this.length = length;
      this.width = width;
   }

   double getLength () { return length; }
   double getWidth () { return width; }

   double area () { return length * width; }
}

class shapes
{
   public static void main (String [] args)
   {
      shape shapeArray [] =
      {
         new circle (52.5, 32.6, 4.7),
         new rectangle (89.6, 78.3),
         new point (62.4, 45.7)
      };

      for (int i = 0; i < shapeArray.length; i++)
      {
           if (shapeArray [i] instanceof point)
           {
               System.out.println ("Point");
               System.out.println ("-----");
           }
           else
           if (shapeArray [i] instanceof circle)
           {
               System.out.println ("Circle");
               System.out.println ("------");
               System.out.println ("x = " +
                    ((circle) shapeArray [i]).getX ());
               System.out.println ("y = " +
                    ((circle) shapeArray [i]).getY ());
               System.out.println ("radius = " +
                    ((circle) shapeArray [i]).getRadius ());
           }
           else
           if (shapeArray [i] instanceof rectangle)
           {
               System.out.println ("Rectangle");
               System.out.println ("---------");
               System.out.println ("length = " +
                    ((rectangle) shapeArray [i]).getLength ());
               System.out.println ("width = " +
                    ((rectangle) shapeArray [i]).getWidth ());
           }

           System.out.println ("Area = " + shapeArray [i].area ());

           // Leave a blank line separator.

           System.out.println ("");
      } 
   }
}
