// isort.java

class node
{
   private int data;
   private node next;

   node (int data)
   {
      setData (data);
      setNext (null);
   }

   void setData (int data)
   {
      this.data = data;
   }

   int getData ()
   {
      return data;
   }

   void setNext (node next)
   {
      this.next = next;
   }

   node getNext ()
   {
      return next;
   }
}

class isort
{
   public static void main (String [] args)
   {
      int [] numbers =
      {
          45, -3, 98, 79, 42, 21, 1000, -333, 42, 42, 0, 100000
      };

      // Create a root node containing the first number.

      node top = new node (numbers [0]);

      // For each remaining number...

      for (int i = 1; i < numbers.length; i++)
      {
           // Create a node for each number.

           node data = new node (numbers [i]);

           // Locate the appropriate insert position.

           node curr = top;
           node prev = null;

           while (curr != null)
              if (curr.getData () > numbers [i])
              {
                  if (prev == null)
                  {
                      data.setNext (top);
                      top = data;
                  }
                  else
                  {
                      data.setNext (prev.getNext ());
                      prev.setNext (data);
                  }

                  break;
              }
              else
              {
                  prev = curr;
                  curr = curr.getNext ();
              }

              // curr == null signifies that the appropriate insert
              // position comes after the last node.

              if (curr == null)
                  prev.setNext (data);
      }

      while (top != null)
      {
         System.out.println (top.getData ());
         top = top.getNext ();
      }
   }
}
