// RAFDemo.java

import java.io.*;

class RAFDemo
{
   public static void main (String [] args) throws IOException
   {
      // Create RandomAccessFile object raf.  A physical
      // employee.dat file is created if it does not exist.
      // Otherwise it is opened.  The file pointer is
      // positioned to the start of the first (and only)
      // record.  The file mode is set to rw for both
      // reading and writing.

      RandomAccessFile raf =
             new RandomAccessFile ("employee.dat", "rw");

      // Display employee.dat's current length.

      System.out.println ("employee.dat length = " +
                          raf.length ());

      // Write employee's first name.

      raf.writeUTF ("John");

      // Write employee's last name.

      raf.writeUTF ("Smith");

      // Write employee's yearly salary.

      raf.writeDouble (45000.0);

      // Set file pointer to start of file.

      raf.seek (0L);

      // Read employee's first name.

      String fname = raf.readUTF ();

      // Read employee's last name.

      String lname = raf.readUTF ();

      // Read employee's yearly salary.

      double salary = raf.readDouble ();

      // Output employee details.

      System.out.println ("First name = " + fname);
      System.out.println ("Last name = " + lname);
      System.out.println ("Salary = " + salary);    

      // Close employee.dat.

      raf.close ();
   }
}
