// timer.java

import java.io.*;

class timer extends Thread implements Serializable
{
   private String name;

   private transient long counter;
   private transient boolean stopped;

   timer (String name)
   {
      this.name = name;
   }

   public void run ()
   {
      long time = System.currentTimeMillis ();

      while (!stopped)
      {
         try
         {
             // Sleep for exactly 10 milliseconds.

             time += 10;
             Thread.sleep (Math.max (0, time -
                                     System.currentTimeMillis ()));
         }
         catch (InterruptedException e) {}

         // Do not change counter while its value is being retrieved.

         synchronized (this)
         {
            counter++;
         }
      }
   }

   void begin ()
   {
      stopped = false;
      start ();
   }

   void end ()
   {
      stopped = true;
   }

   long getCounter ()
   {
      long temp;

      // Ensure that counter is not changed while it's value is
      // being retrieved - in case main thread's quantum expires.

      synchronized (this)
      {
         temp = counter;
      }

      return temp;
   }

   String getTimerName ()
   {
      return name;
   }
}
